﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Data.Objects;
using System.Web;
using System.Linq.Dynamic;
/// <summary>
/// Summary description for ChinookMedia
/// </summary>
public class ChinookMedia
{
    public ChinookMedia()
    {
        //
        // TODO: Add constructor logic here
        //
    }

    private ChinookModel.ChinookEntities _c = new ChinookModel.ChinookEntities();

    public ChinookModel.ChinookEntities c
    {
        get { return _c; }
        set { _c = value; }
    }

    public List<ChinookModel.Track> SelectAllTracksByPlaylistId(int PlaylistId, string sortExpr)
    {

        var query = (from play in c.Playlist
                     from track in play.Track
                     where play.PlaylistId == PlaylistId
                     orderby track.Album.Artist.Name
                     select track);



        foreach (ChinookModel.Track t in query)
        {
            if (!t.AlbumReference.IsLoaded)
            {
                t.AlbumReference.Load();
            }
            if (!t.Album.ArtistReference.IsLoaded)
            {
                t.Album.ArtistReference.Load();
            }
            if (!t.GenreReference.IsLoaded)
            {
                t.GenreReference.Load();
            }
            if (!t.MediaTypeReference.IsLoaded)
            {
                t.MediaTypeReference.Load();
            }
        }
        if (!string.IsNullOrEmpty(sortExpr))
        {
            query = SelectAllSortTracks(query, sortExpr);
        }
        return (List<ChinookModel.Track>)query.ToList<ChinookModel.Track>();

    }

    private IQueryable<ChinookModel.Track> SelectAllSortTracks(IQueryable<ChinookModel.Track> query, string sortExpr)
    {
        if (!String.IsNullOrEmpty(sortExpr))
        {
            query = query.OrderBy(sortExpr);
        }
        return query;
    }


    public List<ChinookModel.Genre> SelectAllGenres()
    {
        var query = (from g in c.Genre
                     orderby g.Name
                     select g);

        return query.ToList<ChinookModel.Genre>();
    }
}
